unit srvmain;

interface

uses
  WinProcs, WinTypes, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, dWinsock, StdCtrls, BuffSock;

type
  TForm1 = class(TForm)
    SendEdit: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    ClientEdit: TEdit;
    ServerSocket1: TBasicServerSocket;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ServerSocket1Accept(Sender: TObject; Socket: TSocketBase);
    procedure Button2Click(Sender: TObject);
    procedure ServerSocket1Info(Sender: TObject; icode: TSockInfo;
      Socket: TSocketBase);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LineReceived( Sender : TLineSocketBase; const line : string;
      complete : Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not ServerSocket1.Conn.Listening then
  begin
    Button1.Caption := 'Close';
    ServerSocket1.Listen( TLineSocket);
  end else
  begin
    Button2.Enabled := False;
    ServerSocket1.Close;
    Button1.Caption := 'Listen';
  end;
end;

procedure TForm1.LineReceived(
  Sender : TLineSocketBase; const line : string; complete : Boolean);
begin
{ for Delphi 1 you must call RebuildLongLine if 'complete' is False }
  ClientEdit.Text := line;
  SendEdit.Text := 'You sent me : '+line;
end;

procedure TForm1.ServerSocket1Accept(Sender: TObject; Socket: TSocketBase);
begin
  (Socket as TLineSocket).OnLineReceived := LineReceived;
  Button2.Enabled := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I, C : Integer;
begin
  C := ServerSocket1.Clientcount;
  for I := 0 to C-1 do
    (ServerSocket1.Client[I] as TLineSocket).WriteLine(SendEdit.Text);
end;

procedure TForm1.ServerSocket1Info(Sender: TObject; icode: TSockInfo;
  Socket: TSocketBase);
begin
  Panel1.Caption := SockInfotoString(icode);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

end.
