{$ifdef win32} unit dwsReg32; {$else} unit dwsReg16; {$endif}

interface
uses
  Classes,    { Protocol      Client              Server        }
  dWinsock,   { General       TBasicClientSocket  TBasicServerSocket }
  BuffSock,   { Buffered      TBinaryClient       TBinaryServer }
              {               TTextClient         TTextServer   }
  TimeSock,   { Time          TTimeClient         TServerSocket }
  SockFact;   { -             -              -             }

procedure Register;

implementation

{ Register our components. }
procedure Register;
begin
  RegisterComponents('dWinsock', [TBasicClientSocket, TBasicServerSocket,
                                  TBinaryClient, TBinaryServer,
                                  TTextClient,   TTextServer,
                                  TTimeClient,   TTimeServer,
                                  TSocketFactory]);
end;


end.
 