unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, IniFiles;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   CgiIniFile : TIniFile;
   CgiIniFileName : String;
   OutputFile : TextFile;
   OutputFileName : String;

begin
   CgiIniFile := TIniFile.Create(ParamStr(1));
   application.processMessages;

   OutputFileName := CgiIniFile.ReadString('System', 'Output File', '');
   CgiIniFile.Free;

   AssignFile( OutputFile, OutputFileName);
   ReWrite(OutputFile);

   Writeln(OutputFile, 'HTTP/1.0 200 OK');
   Writeln(OutputFile, 'Date: Thursday, 12-Jan-96 16:04:30 GMT');
   Writeln(OutputFile, 'Server: WebSite 1.0');
   Writeln(OutputFile, 'Content-type: text/html');
   Writeln(OutputFile, 'Last-modified: Thursday, 25-Jan-96 16:04:30 GMT');
   Writeln(OutputFile, 'Content-length: 5000');
   Writeln(OutputFile, '');
   Writeln(OutputFile, '<HTML><HEAD>');
   Writeln(OutputFile, '<TITLE>Example One</TITLE></HEAD>');
   Writeln(OutputFile, '<BODY BGCOLOR="#FFFFFF">Hello World</BODY></HTML>');

   CloseFile(OutputFile);

   Halt;

end;

end.
