unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Wincgi;

type
  TForm1 = class(TForm)
    WinCGI: TWinCGI;
    Table1: TTable;
    Table1FIRSTNAME: TStringField;
    Table1LASTNAME: TStringField;
    Table1TYPEPERSON: TStringField;
    Table1GENDER: TStringField;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   res : Boolean;      {Check the return value of our methods}
   FirstName : String;
   LastName : String;
   TypePerson : String;
   Gender : String;
begin
with WinCGI do
begin
   InitWinCGI;

   FirstName := GetLiteral('firstname');
   LastName := GetLiteral('lastname');
   TypePerson := GetLiteral('typeperson');
   Gender := GetLiteral('gender');

  {Let's add the record to the PEOPLE.DBF table.  This is not unlike
   standard Delphi Programming.  Of course, in a production situation
   you would do edit checking, check for required fields, etc.}

   Table1.Insert;
   Table1FIRSTNAME.Value := FirstName;
   Table1LASTNAME.Value := LastName;
   Table1TYPEPERSON.Value := TypePerson;
   Table1GENDER.Value := Gender;
   Table1.Post;

   SendHTTPHeader; {Method that sends 5 lines to the server,
                    including a properly formatted GMT line
                    and a line that reads the WebServerName
                    property from our component}

   Send('<HTML><HEAD>');     {Writes a line to output file}
   Send('<TITLE>Example Four</TITLE></HEAD>');
   Send('<BODY BGCOLOR="#FFFFFF"><HR>Hello ' + FirstName + ' ' + LastName + ', <P>');
   Send('<H2>Using Our Delphi Component!</H2>');
   Send('A record has been added to the database.<P>');
   Send('The Request Method is <B>' + REQUEST_METHOD + '</B>.<BR>');
   Send('The Server Name is <B>' + SERVER_NAME + '</B>.<BR>');
   Send('Your IP Address is <B>' + REMOTE_ADDR + '</B>.<P>');

   Send('Sir, the time on deck is <B>' + DateTimeToStr(Now) + '</B><P><HR>');

   Send('You are a <B>' + Gender + '</B> and a really <B>' + TypePerson + '</B> individual.');
   Send('</BODY></HTML>');

   CloseWinCGI; {Method that closes the output File}

   Halt; {Stops the program.  The Web Server takes control and
          delivers the output file to the user.}
end;

end;


end.
