unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Wincgi, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    WinCGI: TWinCGI;
    Table1FIRSTNAME: TStringField;
    Table1LASTNAME: TStringField;
    Table1TYPEPERSON: TStringField;
    Table1GENDER: TStringField;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   res : Boolean;      {Check the return value of our methods}
   criteria : String;

begin
with WinCGI do
begin
   InitWinCGI;

   criteria := GetLiteral('lastname');

  {Let's add the record to the PEOPLE.DBF table.  This is not unlike
   standard Delphi Programming.  Of course, in a production situation
   you would do edit checking, check for required fields, etc.}

   SendHTTPHeader; {Method that sends 5 lines to the server,
                    including a properly formatted GMT line
                    and a line that reads the WebServerName
                    property from our component}

   Send('<HTML><HEAD>');     {Writes a line to output file}
   Send('<TITLE>Example Four</TITLE></HEAD>');
   Send('<BODY BGCOLOR="#FFFFFF"><HR>');
   Send('<H2>Using Our Delphi Component!</H2>');


   {Here's where we check to see if the search is successful or
    not.  The page that is returned is entirely dependent on whether
    the record is found and what's in the record - A dynamic Page!!}
   if Table1.FindKey([criteria]) then
   begin
        Send('<H2>Found It!</H2>');
        Send('Here''s the rest of the info..<P>');
        Send('First Name: <B>' + Table1FIRSTNAME.Value + '</B><P>');
        Send('Last Name: <B>' + Table1LASTNAME.Value + '</B><P>');
        Send('They are a <B>' + Table1GENDER.Value + '</B> and a really <B>');
        Send(Table1TYPEPERSON.Value + '</B> person.<P>');
        Send('Thanks for Asking!');
   end
   else
   begin
        Send('<H2>Sorry!</H2>');
        Send('Couldn''t find anyone with the last name <B>' + criteria + '</B><P>');
        Send('Click the BACK button on your browser and try again.<P>');
   end;

   Send('Sir, the time on deck is <B>' + DateTimeToStr(Now) + '</B><P><HR>');
   Send('</BODY></HTML>');

   CloseWinCGI; {Method that closes the output File}

   Halt; {Stops the program.  The Web Server takes control and
          delivers the output file to the user.}
end;

end;


end.
 