unit Unit2;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls;

type
  TSendPictureForm = class(TForm)
    PictureEdit: TEdit;
    Button1: TButton;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Label2: TLabel;
    Image1: TImage;
    Label3: TLabel;
    ServerEdit: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SendPictureForm: TSendPictureForm;

implementation

{$R *.DFM}
uses dWSUtils;

procedure TSendPictureForm.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    PictureEdit.Text := OpenDialog1.FileName;
    Image1.Picture.Bitmap.LoadFromFile(OpenDialog1.FileName);
{$ifndef Win32}
    if GetFileSize( OpenDialog1.FileName) >= ($FFFF-1) then
    begin
      ShowMessage(
        'You are using Delphi 1 - you cannot send images over 64K in size.');
      PictureEdit.Text := '';
      Image1.Picture.Bitmap.Width := 0;
      Image1.Picture.Bitmap.Height := 0;
    end;
{$endif}
  end;
end;

procedure TSendPictureForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if ModalResult = mrOK then
    CanClose := (PictureEdit.Text <> '') and (ServerEdit.Text <> '');
end;

end.
